Structure CharArray
  c.c[0]
EndStructure

#NHX = 10;16
#eps = 1e-17
#ntp = 25

EnableExplicit

Procedure.d expm(p.d, ak.d)
  Protected.i i, j
  Protected.d p1, pt, r
  Static Dim tp.d(#ntp), tp1.i = 0
  
  If tp1 = 0
    tp1 = 1
    tp(0) = 1
    
    For i = 1 To #ntp-1 : tp(i) = 2 * tp(i-1) : Next i
  EndIf
  
  If ak = 1 : ProcedureReturn 0 : EndIf
  
  For i = 0 To #ntp-1 : If tp(i) > p : Break : EndIf : Next i
  
  pt = tp(i-1)
  p1 = p
  r = 1
  
    For j = 1 To i
    If p1 >= pt
      r = 16 * r
      r = r - Int((r / ak)) * ak
      p1 = p1 - pt
    EndIf
    pt = 0.5 * pt
    If pt >= 1
      r = r * r;
      r = r - Int((r / ak)) * ak
    EndIf
  Next j
  
  ProcedureReturn r
EndProcedure

Procedure.d series (m.i, id.i)
  Protected k.i, Count.i
  Protected.d ak, p, s, t;, eps
  
  s = 0
  Count = id - 1
  
  For k = 0 To Count
    ak = 8 * k + m
    p = id - k
    t = expm(p, ak)
    s = s + t / ak
    s = s - Int(s)
  Next k
  
  Count = id + 100
  
  For k = id To Count
    ak = 8 * k + m
    t = Pow(16, (id - k)) / ak
    If (t < #eps) : Break : EndIf
    s = s + t
    s = s - Int(s)
  Next k
  
  ProcedureReturn s
  
EndProcedure

Procedure ihex(x.d, nhx.i,  *c.CharArray)
  Protected i.i, y.d, *Table.CharArray=?HEX_Table
  
  y = Abs(x)
  
  For i=0 To nhx-1
    y = 16 * (y - Round(y, #PB_Round_Down))
    *c\c[i]=*Table\c[Int(y)]
  Next i
  
  ProcedureReturn
  
  DataSection
    HEX_Table:
    Data.c '0', '1', '2', '3', '4', '5', '6', '7'
    Data.c '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'
  EndDataSection
  
EndProcedure

Procedure CalcPI(Pos, *Buff)
  Protected.d pid, s1, s2, s3, s4
  
  s1 = series(1, Pos)
  s2 = series(4, Pos)
  s3 = series(5, Pos)
  s4 = series(6, Pos)
  
  pid = 4 * s1 - 2 * s2 - s3 - s4
  pid = pid - Int(pid) + 1
  ihex (pid, #NHX, *Buff+Pos)
EndProcedure

DisableExplicit

Max = 20000
BuffSize = Round(Max, #PB_Round_Up) ;* 10
Dim StrBuff(BuffSize)

Pos=1000

OpenConsole()
Time = ElapsedMilliseconds()

For i=0 To Max Step 10
  CalcPI(i, @StrBuff())
  If i>=Pos
    Pos=i+1000
    PrintN("Count: "+i+" Time: "+StrF((ElapsedMilliseconds()-Time)/1000, 2)+" sec")
  EndIf
Next i

Delay(2000)

; CreateFile(0, "pi.txt")
; WriteData(0, @StrBuff(), BuffSize)
; CloseFile(0)
; IDE Options = PureBasic 6.00 Alpha 1 (Windows - x64)
; CursorPosition = 108
; FirstLine = 90
; Folding = -
; Optimizer
; Executable = PI_ASM.exe
; DisableDebugger
; CompileSourceDirectory
; Compiler = PureBasic 6.00 Alpha 1 (Windows - x64)